"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InstrumentWalker = void 0;

var _solidityParserAntlr = _interopRequireDefault(require("solidity-parser-antlr"));

class InstrumentWalker {
  constructor(instrumenter) {
    this.instrumenter = instrumenter;
  }

  walk(ast) {
    _solidityParserAntlr.default.visit(ast, {
      BreakStatement: node => {
        this.instrumenter.instrumentStatement(node);
      },
      ContinueStatement: node => {
        this.instrumenter.instrumentStatement(node);
      },
      ContractDefinition: node => {
        this.instrumenter.instrumentContractDefinition(node);
      },
      EmitStatement: node => {
        this.instrumenter.instrumentStatement(node);
      },
      ExpressionStatement: node => {
        this.instrumenter.instrumentStatement(node);
      },
      FunctionDefinition: node => {
        this.instrumenter.instrumentFunction(node);
      },
      IfStatement: node => {
        this.instrumenter.instrumentStatement(node);
        this.instrumenter.instrumentIfStatement(node);
      },
      ModifierDefinition: node => {
        this.instrumenter.instrumentFunction(node);
      },
      ReturnStatement: node => {
        this.instrumenter.instrumentStatement(node);
      },
      ThrowStatement: node => {
        this.instrumenter.instrumentStatement(node);
      },
      VariableDeclarationStatement: node => {
        this.instrumenter.instrumentStatement(node);
      },
      WhileStatement: node => {
        this.instrumenter.instrumentStatement(node);
      }
    });
  }

}

exports.InstrumentWalker = InstrumentWalker;
//# sourceMappingURL=instrumentWalker.js.map